% Script for signage recycling study; 2012/04/11PL
%now updated for go/go & no go signs, with speeded block vs. unspeeded
%block


% Reseed the random-number generator for each expt.
rand('state',sum(100*clock));
Screen('Preference', 'SkipSyncTests', 1);

present_instr=1; %present instructions?  1=='on', 0=='off';

%defaults, changed with dialogue input below%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%Manual entry of subject ID and order
subject='00002';
order='b';
sex='na';
age='na';
handed='na';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if order=='a'
	sideorder=1;
elseif order=='b'
	sideorder=2;
end
filename=['.\subjects\', subject, '_', order, '.txt'];
%end of defaults%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%ask whether to collect new touch_plane_info or use saved
ButtonName = questdlg('Perform calibraion?', ...
                     'New Calibration or load', ...
                     'New Calibration', 'Load Calibration', 'Quit', 'New Calibration');
switch ButtonName,
 case 'New Calibration',
    [touch_plane_info, client] = opti_setup_touch_plane_srt;    
 case 'Load Calibration',
    [touch_plane_info, client] = use_last_touch_plane;
 case 'Quit',
    client.Uninitialize;
    screen('closeAll');
    return;      
end % switch
% set up optitrak
% [touch_plane_info, client] = opti_setup_touch_plane_srt;
optiData = client.GetLastFrameOfData;
distToTouch = -12/1000; %marker above this height will not record as touch (in mm)

%%%%%%%%%%%%%%%%%%%%%%%
%Dialogue input: can comment this block out for testing (in which case defaults above will be used)
prompt={'Participant ID:', 'Sign Group(a/b)', 'Sex(m/f):', 'Age:', 'Handed(l/r/b):'};
def = {'', '', '', '', ''};
title = 'Signage Recycling';
lineNo=1;
details= inputdlg(prompt, title, lineNo, def);

%this is dumb, just use lower(details{2}) to count both 'A' and 'a'
acomp=regexpi(details{2}, '[a|1]');
bcomp=regexpi(details{2}, '[b|2]');
if isempty(acomp) && isempty(bcomp)
	clear all; close all; Screen('CloseAll');
	disp('***Error: please enter ''a'' or ''b'' for Block Order***');
	break;
elseif isempty(bcomp) && ~isempty(acomp) 
	sideorder=1;
	details{2}='a';
elseif isempty(acomp) && ~isempty(bcomp)
	sideorder=2;
	details{2}='b';
else
	clear all; close all; Screen('CloseAll');
	disp('***Error: please enter only ''a'' OR ''b'' for Block Order***');
	break;
end
subject=details{1};
order=details{2};
sex=details{3};
age=details{4};
handed=details{5};
filename=['.\subjects\', subject, '_', order, '.txt'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fout=fopen(filename, 'a'); %appends to file, will not overwrite
fprintf(fout, 'subject\tsign_group\tsex\tage\thanded\t');
fprintf(fout, 'block\ttrial\tbin_type\tbin_type_num\t');
fprintf(fout, 'col_icon\tcol_icon_num\tgo_gng\tgo_gng_num\t');
fprintf(fout, 'posComp\tposGarb\tposPap\tposRecyc\t');
fprintf(fout, 'word\tword_category\tword_category_num\tword_in_pic\tgo_side_group\tgo_side_group_num\t');
fprintf(fout, 'bin_response\tbin_response_cat_num\tbin_accuracy\tbin_rxn\tbin_rsp\tbin_tot\tword_earlystarts\n');


% Embed core of code in try ... catch statement. If anything goes wrong
% inside the 'try' block (Matlab error), the 'catch' block is executed to
% clean up, save results, close the onscreen window etc.
try
% Get screenNumber of stimulation display. We choose the display with
% the maximum index, which is usually the right one, e.g., the external
% display on a Laptop:
%does this find screen ok?
screens=Screen('Screens');
screenNumber=max(screens);

% Hide the mouse cursor:
HideCursor;

% Returns as default the mean gray value of screen:
gray=GrayIndex(screenNumber); 
white=WhiteIndex(screenNumber);


% Open a double buffered fullscreen window on the stimulation screen
% 'screenNumber' and choose/draw a gray background. 'w' is the handle
% used to direct all drawing commands to that window - the "Name" of
% the window. 'wRect' is a rectangle defining the size of the window.
% See "help PsychRects" for help on such rectangles and useful helper
% functions:
[w, wRect]=Screen('OpenWindow',screenNumber, white);
mX=wRect(3); %max X of screen
mY=wRect(4); %max Y of screen
hz = frameRate(w);
black=BlackIndex(w);
% Set text size (Most Screen functions must be called after
% opening an onscreen window, as they only take window handles 'w' as
% input:
Screen('TextSize', w, 24);
Screen('TextFont', w, 'Arial');



% Do dummy calls to GetSecs, WaitSecs, KbCheck to make sure
% they are loaded and ready when we need them - without delays
% in the wrong moment:
KbCheck;
WaitSecs(0.1);
GetSecs;    

% Set priority for script execution to realtime priority:
priorityLevel=MaxPriority(w);
Priority(priorityLevel);



%%%%%%%%% VARIABLES %%%%%%%%%%%%%%
%%%setting and loading variables before we start the actual experiment
totalblocks=2;
block=1; %counts up after 48 trials
% wBr=m2(scr, rect, width, height, totalblocks);  %block message
trialsperblock=48;
totaltrials=trialsperblock*totalblocks; % 48*2=96



if sideorder==1 %left go, right nogo
    [colgngimages colgoimages icongngimages icongoimages]= textread('stimuli3\stimulusfile5L.txt', '%s %s %s %s');
elseif sideorder==2 %right go, left nogo
    [colgngimages colgoimages icongngimages icongoimages]= textread('stimuli3\stimulusfile5R.txt', '%s %s %s %s');
end
for count=1:4
	colgo=imread(['stimuli3\',colgoimages{count}]);
	texcolgoimages{count}=Screen('MakeTexture', w, colgo); %storing actual image textures into texarray
	colgng=imread(['stimuli3\',colgngimages{count}]);
	texcolgngimages{count}=Screen('MakeTexture', w, colgng);
	icongo=imread(['stimuli3\',icongoimages{count}]);
	texicongoimages{count}=Screen('MakeTexture', w, icongo);
	icongng=imread(['stimuli3\',icongngimages{count}]);
	texicongngimages{count}=Screen('MakeTexture', w, icongng);
		
end



homebox=imread(['stimuli\home_box1.PNG']);
texhomebox=Screen('MakeTexture', w, homebox); %storing the homebox image into variable

old_box=imread(['stimuli\same_box3.PNG']);
new_box=imread(['stimuli\different_box3.PNG']);

bintype={texcolgoimages, texcolgngimages, texicongoimages, texicongngimages}; %store texarrays into bintype array; referenced by alltrials {1}
% positions={[12.47 mY*58/100-227.5 262.47 mY*58/100+96], [mX*38/100-125 mY*36/100-227.5 mX*38/100+125 mY*36/100+96], [mX*62/100-125 mY*36/100-227.5 mX*62/100+125 mY*36/100+96], [761.53 mY*58/100-227.5 1011.53 mY*58/100+96]};
% positions={[15.59 290.59 328.09 721.92], [330.15 65.31 642.65 496.64], [637.35 65.31 949.85 496.64], [951.88 290.59 1264.38 721.92]};
positions={[62.47 mY*58/100-162.82 262.47 mY*58/100+96], [mX*38/100-72 mY*36/100-162.82 mX*38/100+122 mY*36/100+96], [mX*62/100-122 mY*36/100-162.82 mX*62/100+72 mY*36/100+96], [761.53 mY*58/100-162.82 961.53 mY*58/100+96]};


% positions={[12.47 mY*58/100-96 262.47 mY*58/100+96], [mX*38/100-125 mY*36/100-96 mX*38/100+125 mY*36/100+96], [mX*62/100-125 mY*36/100-96 mX*62/100+125 mY*36/100+96], [761.53 mY*58/100-96 1011.53 mY*58/100+96]};
% positions={[53.0244 mY*60/100-96 303.0244 mY*60/100+96], [mX*35/100-125 mY*45/100-96 mX*35/100+125 mY*45/100+96], [mX*65/100-125 mY*45/100-96 mX*65/100+125 mY*45/100+96], [720.9756 mY*60/100-96 970.9756 mY*60/100+96]};
% positions={[mX*20/100-125 mY*60/100-52 mX*20/100+125 mY*60/100+52], [mX*35/100-125 mY*45/100-52 mX*35/100+125 mY*45/100+52], [mX*65/100-125 mY*45/100-52 mX*65/100+125 mY*45/100+52], [mX*80/100-125 mY*60/100-52 mX*80/100+125 mY*60/100+52]}; 
%e.g., first coord set: positions{1}; reference with alltrials{2}
[words cats catsnum inpic earlystart]=textread('./lists/wordlist3.txt', '%[^\t]\t%[^\t]\t%[^\t]\t%[^\t]\t%[^\n]'); %words(1)='food scraps', cats(1)='compost', catsnum(1)='1'; reference with alltrials{3}
earlystart=str2double(earlystart); %increment this for words which have early responses (before bins appear); possible exclusion criterion if this is high
[pracwords pcats pcatsnum pinpic pearlystart]=textread('./lists/practice/pracwords.txt', '%[^\t]\t%[^\t]\t%[^\t]\t%[^\t]\t%[^\n]');

varonset={3 3.2 3.4 3.6 3.8 4}; %vary the onset delay for the bins



alltrials=func_settrials(length(words));  %fill alltrials array with randomized indices for referencing variable arrays
%alltrails {i, 1} => reference bintype (1-24= colour go, 25-48=icon go, etc.)
%alltrials {i, 2} => reference binorder, i.e., order of positions
%alltrials {i, 3} => reference words/cats


%label vars for writing to text file
bintypeLab={'col_go', 'col_gng', 'icon_go', 'icon_gng'};
bintypeColIconLab={'col', 'col', 'icon', 'icon'};
bintypeGoGNGLab={'go', 'gng', 'go', 'gng'};
bintypeLab2={1, 2, 3, 4};
bintypeColIconLab2={1, 1, 2, 2};
bintypeGoGNGLab2={1, 2, 1, 2};


% positionsLabel={'first', 'second', 'third', 'fourth'}; %just use alltrials{i, 2}
% memProbeLab={'same', 'different'};
sideorderLab={'Left', 'Right'};
sideorder_numLab={1, 2};

disp('xxxxxooooox');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%Main trial loop
rset=randperm(totaltrials);
pracset=randperm(totaltrials);
thistrial=1;
practrial=1;
showninstr=0; %this var needed to make sure instr aren't shown twice after earlyonset in trial 1
while thistrial<=totaltrials %sub 12 for totaltrials for experiment + break testing
    if mod(thistrial, trialsperblock)==2  %this is needed to reset showninstr for block 2+ %sub 6 for trialsperblock for break testing
		showninstr=0;
    end
	if mod(thistrial, trialsperblock)==1 | practrial==1  %sub 6 for trialsperblock for break testing
		if thistrial==1
			block=1;
		elseif thistrial>1 & showninstr==0
			%sideorder=(abs(sideorder-2))+1;  %this expression alternates repeatedly between 1 and 2
			block=block+1;
			%starting speedorder is either 1 or 2, alternate if reach second block
		end
		%break screen
		if present_instr==1 & showninstr==0
			%present instructions for the appropriate speedorder
			[instr_files]=textread(['./instructions3/instr', num2str(block), '.txt'], '%[^\n]');
			for count=1:length(instr_files)
				instr_img=imread(['./instructions3/', instr_files{count}]);
				instr_tex=Screen('MakeTexture', w, instr_img);
				Screen('DrawTexture', w, instr_tex, [], [0, 0, mX, mY]);
				Screen('Flip', w);
				WaitSecs(3);
                touchFlag = 0;
                while ~touchFlag
                    [touchFlag,x,y] = detectTouch_opti(touch_plane_info,distToTouch,optiData);

                    [touch,secs,keyCode] = KbCheck;

                    if find(keyCode) == 27 %ESCAPE
                        fclose(fout);
                        client.Uninitialize;
                        Screen('CloseAll');
                        return;
                    end
                    waitsecs(1/hz);
                end
% 				[secs, keyCode, deltaSecs] = KbWait;
            end
            showninstr=1;
		end
	end
	if practrial<=5
		i=pracset(practrial);
	elseif practrial > 5
		i=rset(thistrial);
	end
    rerandomizeFlag = 0;
    RxnTime=0; %set back to 0 so won't cause problems with next trial
    RspTime=0;
    disp('XOXOXOXOXOXOXOXOOXOXOXOXOXO');	%%%error testing line

	
	Screen('DrawTexture', w, texhomebox, [], [mX/2-50, mY*9/10-50, mX/2+50, mY*9/10+50]);
	Screen('Flip', w);
% 	WaitSecs(1);	

    %wait for touch to home box, then add border
    touchFlag = 0;
    y = 0;
    x = 0;
    while y < mY*9/10-50 | y > mY*9/10+50 | x < mX/2-50 | x > mX/2+50 | ~touchFlag % wait for press
        [touchFlag,x,y] = detectTouch_opti(touch_plane_info,distToTouch,optiData);
        
        [touch,secs,keyCode] = KbCheck;
        if find(keyCode) == 27 %ESCAPE
			fclose(fout);
            client.Uninitialize;
            Screen('CloseAll');
            return;
        end
        waitsecs(1/hz);
    end
    
	%draw frame around home box
	Screen('DrawTexture', w, texhomebox, [], [mX/2-50, mY*9/10-50, mX/2+50, mY*9/10+50]);
	Screen('FrameRect', w, black, [mX/2-60, mY*9/10-60, mX/2+60, mY*9/10+60], 10);
	Screen('Flip', w);
	
	%Wait for 1 sec and make sure finger is still on home box
	% WaitSecs(1);	
	tooEarlyFlag=0;
	tic;
	timeonset=toc;
	while ~tooEarlyFlag & timeonset < 1
		timeonset=toc;
		[touchFlag,x,y] = detectTouch_opti(touch_plane_info,distToTouch,optiData);
		if touchFlag==0 | y < mY*9/10-50 | y > mY*9/10+50 | x < mX/2-50 | x > mX/2+50
			tooEarlyFlag = 1;
		end
		waitsecs(1/hz);		
	end

	
	% Present word/object
	if ~tooEarlyFlag
		Screen('DrawTexture', w, texhomebox, [], [mX/2-50, mY*9/10-50, mX/2+50, mY*9/10+50]);
		Screen('FrameRect', w, black, [mX/2-60, mY*9/10-60, mX/2+60, mY*9/10+60], 10);
		if practrial<=5 %%%%practice words vs actual words
			message=pracwords{practrial};
		elseif practrial>5
			message=words{alltrials{i,3}};   
		end
		DrawFormattedText(w, message, 'center', mY*3/5+100, black);	
		Screen('Flip', w);
	end
	
	% Wait for variable time and make sure finger is still on home box
	% WaitSecs(1);
	tic;
	timeonset=toc;
	while ~tooEarlyFlag & timeonset < varonset{randi(6)}
		timeonset=toc;
		[touchFlag,x,y] = detectTouch_opti(touch_plane_info,distToTouch,optiData);
		if touchFlag==0 | y < mY*9/10-50 | y > mY*9/10+50 | x < mX/2-50 | x > mX/2+50
			tooEarlyFlag = 1;
            rerandomizeFlag = 1;
		end
		waitsecs(1/hz);		
	end		
	
		
	% Present bins
	if ~tooEarlyFlag
		Screen('DrawTexture', w, texhomebox, [], [mX/2-50, mY*9/10-50, mX/2+50, mY*9/10+50]);
		DrawFormattedText(w, message, 'center', mY*3/5+100, black);
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{1}, [], positions{alltrials{i,2}(1)}); %350 x 150; 250 x 105  %compost
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{2}, [], positions{alltrials{i,2}(2)}); %350 x 150  %garbage
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{3}, [], positions{alltrials{i,2}(3)}); %350 x 150  %paper
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{4}, [], positions{alltrials{i,2}(4)}); %350 x 150  %recycling
        Screen('FrameRect', w, black, positions{1}, 1);
        Screen('FrameRect', w, black, positions{2}, 1);
        Screen('FrameRect', w, black, positions{3}, 1);
        Screen('FrameRect', w, black, positions{4}, 1);
% 		Screen('FrameRect', w, black, [positions{alltrials{i,2}(4)}(1)-8, positions{alltrials{i,2}(4)}(2)-8, positions{alltrials{i,2}(4)}(3)+8, positions{alltrials{i,2}(4)}(4)+8], 11);
		Screen('Flip', w);
    end
	    
   %Wait for a response touch to one of the bins and get bin, whether bin
	% is correct or not for given word/object, plus both
    %liftoff/leave home time=Rxn and travel time = Rsp, for output
    % also mark which bin gets the black frame after response
	binResponseFlag=0;
	initiateFlag=0;
	binAcc=0; %by default binAcc is 0, if chose right set to 1 below
	tic;
	while ~tooEarlyFlag & ~binResponseFlag
		[touchFlag,x,y] = detectTouch_opti(touch_plane_info,distToTouch,optiData);
		if (touchFlag==0 | y < mY*9/10-50 | y > mY*9/10+50 | x < mX/2-50 | x > mX/2+50) & initiateFlag==0
			RxnTime=toc
			initiateFlag=1;
		end
		if touchFlag==1 & x > positions{alltrials{i,2}(1)}(1) & y > positions{alltrials{i,2}(1)}(2) & x < positions{alltrials{i,2}(1)}(3) & y < positions{alltrials{i,2}(1)}(4)
			RspTime=toc
			responsebin='Compost'
			responsebin_catsnum=1;
			frm=1; %used to denote which bin gets the black frame around it after response
			if strcmp(cats{alltrials{i,3}}, 'Compost')
				binAcc=1;
			end
			binResponseFlag=1;
		elseif touchFlag==1 & x > positions{alltrials{i,2}(2)}(1) & y > positions{alltrials{i,2}(2)}(2) & x < positions{alltrials{i,2}(2)}(3) & y < positions{alltrials{i,2}(2)}(4)
			RspTime=toc
			responsebin='Garbage'
			responsebin_catsnum=4;
			frm=2;
			if strcmp(cats{alltrials{i,3}}, 'Garbage')
				binAcc=1;
			end
			binResponseFlag=1;
		elseif touchFlag==1 & x > positions{alltrials{i,2}(3)}(1) & y > positions{alltrials{i,2}(3)}(2) & x < positions{alltrials{i,2}(3)}(3) & y < positions{alltrials{i,2}(3)}(4)
			RspTime=toc
			responsebin='Paper'
			responsebin_catsnum=2;
			frm=3;
			if strcmp(cats{alltrials{i,3}}, 'Paper')
				binAcc=1;
			end
			binResponseFlag=1;            
		elseif touchFlag==1 & x > positions{alltrials{i,2}(4)}(1) & y > positions{alltrials{i,2}(4)}(2) & x < positions{alltrials{i,2}(4)}(3) & y < positions{alltrials{i,2}(4)}(4)
			RspTime=toc
			responsebin='Recycling'
			responsebin_catsnum=3;
			frm=4;
			if strcmp(cats{alltrials{i,3}}, 'Recycling')
				binAcc=1;
			end
			binResponseFlag=1;  
		end
		waitsecs(1/hz);	
	end
		
    % Present bins again but with touched bin marked with black frame
    if ~tooEarlyFlag
        wordcategory=cats{alltrials{i,3}}
        binAcc %shows up in matlab command window

		Screen('DrawTexture', w, texhomebox, [], [mX/2-50, mY*9/10-50, mX/2+50, mY*9/10+50]);
		DrawFormattedText(w, message, 'center', mY*3/5+100, black);
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{1}, [], positions{alltrials{i,2}(1)}); %350 x 150; 250 x 105  %compost
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{2}, [], positions{alltrials{i,2}(2)}); %350 x 150  %garbage
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{3}, [], positions{alltrials{i,2}(3)}); %350 x 150  %paper
		Screen('DrawTexture', w, bintype{alltrials{i,1}}{4}, [], positions{alltrials{i,2}(4)}); %350 x 150  %recycling
        Screen('FrameRect', w, black, positions{1}, 1);
        Screen('FrameRect', w, black, positions{2}, 1);
        Screen('FrameRect', w, black, positions{3}, 1);
        Screen('FrameRect', w, black, positions{4}, 1);
		Screen('FrameRect', w, black, [positions{alltrials{i,2}(frm)}(1)-8, positions{alltrials{i,2}(frm)}(2)-8, positions{alltrials{i,2}(frm)}(3)+8, positions{alltrials{i,2}(frm)}(4)+8], 11);
		Screen('Flip', w);
        WaitSecs(1);
    end

    %now shake up the 4 memory array positions shown above and show the 4
    %memory probe items along with 'new' and 'old' response boxes
	% note: 'new' and 'old' have been replaced with 'different' and 'same', respectively; 20120502PL
	%GONE
    
    %Wait for a response touch to one of the mem response boxes
    % and get the choice (old or new), as well as whether the choice is
    % correct or not for output.
    % Also mark coordinates for box which gets the black frame after response
	%GONE
    
        
    %Finally, mark the chosen mem response box with a black frame
    %and output the line of data to text file
	%GONE

	if ~tooEarlyFlag & practrial > 5
		
		%%%%%%%%%%%%%FILE OUTPUT- only if not practice trial
		RxnTime=RxnTime*1000;
		RspTime=RspTime*1000;
		RspTime=RspTime-RxnTime;

        % fprintf(fout, 'subject\tblock_order\tsex\tage\thanded\t');
        % fprintf(fout, 'block\ttrial\tbin_type\tbin_type_num\t');
        % fprintf(fout, 'col_icon\tcol_icon_num\tgo_gng\tgo_gng_num\t');
        % fprintf(fout, 'posComp\tposGarb\tposPap\tposRecyc\t');
        % fprintf(fout, 'word\tword_category\tword_category_num\tword_in_pic\tsideorder_conditon\tsideorder_condition_num\t');
        % fprintf(fout, 'bin_response\tbin_response_cat_num\tbin_accuracy\tbin_rxn\tbin_rsp\tbin_tot\tword_earlystarts\n');
		fprintf(fout, '%s\t%s\t%s\t%s\t%s\t', subject, order, sex, age, handed);
        fprintf(fout, '%d\t%d\t%s\t%d\t', block, thistrial, bintypeLab{alltrials{i,1}}, bintypeLab2{alltrials{i,1}});
        fprintf(fout, '%s\t%d\t%s\t%d\t', bintypeColIconLab{alltrials{i,1}}, bintypeColIconLab2{alltrials{i,1}}, bintypeGoGNGLab{alltrials{i,1}}, bintypeGoGNGLab2{alltrials{i,1}});
		fprintf(fout, '%d\t%d\t%d\t%d\t', alltrials{i,2}(1), alltrials{i,2}(2), alltrials{i,2}(3), alltrials{i,2}(4));
		fprintf(fout, '%s\t%s\t%d\t%d\t%s\t%d\t', words{alltrials{i,3}}, cats{alltrials{i,3}}, str2num(catsnum{alltrials{i,3}}), str2num(inpic{alltrials{i,3}}), sideorderLab{sideorder}, sideorder_numLab{sideorder});
		fprintf(fout, '%s\t%d\t%d\t%.0f\t%.0f\t%.0f\t%d\n', responsebin, responsebin_catsnum, binAcc, RxnTime, RspTime, (RxnTime+RspTime), earlystart(alltrials{i,3}));

		       
		thistrial= thistrial+1;  %trial num only advances if they don't respond too early
		WaitSecs(1.5);
    
	elseif ~tooEarlyFlag & practrial <=5
		%Got through practice trial successfully, advance to next practice trial
   		RxnTime=RxnTime*1000; %need this for "too slow" message during practice
        RspTime=RspTime*1000;
        RspTime=RspTime-RxnTime;        
		practrial=practrial+1;
		WaitSecs(1.5);

%         bintypeLab{alltrials{i,1}}  %checking to see in command window
%         bintypeColIconLab{alltrials{i,1}}
%         bintypeGoGNGLab{alltrials{i,1}}
%         speedLab{speedorder}
	%%This section is needed for when Ss see the word but respond before bins appear- in this case, we need to rerandomize 
	% the current and all remaining trials so that the same word doesn't appear again.  Error message 'too early' and beep are also presented.
    elseif rerandomizeFlag == 1
		if practrial>5
			earlystart(alltrials{i,3})=earlystart(alltrials{i,3})+1; %increment this var to note how many times this word has produced an early start
	
			rerand=rset(thistrial:end);   %only rerandomize the remaining trials
			rerand=shuffle(rerand);
			rset(thistrial:end)=rerand;
        end
		
		DrawFormattedText(w, 'Too early!\n\nWait for bins to appear\n\nbefore responding', 'center', 'center', [255 0 0]);
		Screen('Flip', w);
		beep = MakeBeep(1000,0.15);
		Snd('Play',beep);
        WaitSecs(2);
        RxnTime=0; %don't want "too late" message appearing when too early
        RspTime=0;
	end
	if (RspTime+RxnTime> 1800)
		DrawFormattedText(w, 'Too slow!\n\nRespond as soon as\n\nthe bins appear', 'center', 'center', [255 0 0]);
		Screen('Flip', w);
		beep = MakeBeep(1000,0.15);
		Snd('Play',beep);
        WaitSecs(3);
    end
    if practrial==6
        DrawFormattedText(w, 'You have finished the practice trials.\n\nTouch anywhere to begin this study', 'center', 'center', [0 0 0]);
        Screen('Flip', w);
        WaitSecs(3);
        touchFlag = 0;
        while ~touchFlag
            [touchFlag,x,y] = detectTouch_opti(touch_plane_info,distToTouch,optiData);

            [touch,secs,keyCode] = KbCheck;

            if find(keyCode) == 27 %ESCAPE
                fclose(fout);
                client.Uninitialize;
                Screen('CloseAll');
                return;
            end
            waitsecs(1/hz);
        end			
        practrial=practrial+1;
    end
end
%%%End main trial loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

DrawFormattedText(w, 'You are done this part of the study!\n\nThanks!', 'center', 'center', black); 
Screen('Flip', w);
WaitSecs(2.5);

Screen('CloseAll');
client.Uninitialize;
fclose(fout);
ShowCursor;

% wordratings(subject, order);

catch
    % catch error: This is executed in case something goes wrong in the
    % 'try' part due to programming error etc.:
    Screen('CloseAll');
	% fclose(fout);
	fclose('all');
    client.Uninitialize;
    ShowCursor;
    % fclose('all');
    Priority(0);
	disp('***Error: something''s wrong in catch***');

end % try ... catch %

